> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nmbr.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Submit a form

> Endpoint to submit a Form.

The following example is for an ROE, but the same flow will work for any submittable form.



## OpenAPI

````yaml /spec/openapi.json post /forms/{form}/submit
openapi: 3.0.0
info:
  title: Nmbr API
  description: API to interact with Nmbr Payroll
  version: 1.0.0
servers:
  - url: https://sandbox.nmbr.co/services/payroll
security:
  - CompanyToken: []
tags:
  - name: Accounting Codes
  - name: Accounting Code Rules
  - name: Adjustments
  - name: Allowances
  - name: Allowance Line Items
  - name: Allowance Types
  - name: Async Tasks
  - name: Bank Accounts
  - name: Business Entities
  - name: Business Entity Verifications
  - name: Business Entity ROE Authorizations
  - name: Business Presets
  - name: Calculations
  - name: Companies
  - name: Contractors
  - name: Deductions
  - name: Deduction Line Items
  - name: Deduction Types
  - name: Earnings
  - name: Earning Line Items
  - name: Earning Types
  - name: Effective Tax Properties
  - name: Employees
  - name: Employee Benefits
  - name: Employee Benefit Line Items
  - name: Employee Benefit Types
  - name: Employer Benefits
  - name: Employer Benefit Line Items
  - name: Employer Benefit Types
  - name: Employer Statutory Withholding Line Items
  - name: Employer Statutory Withholding Types
  - name: Forms
  - name: Form Batches
  - name: Form Types
  - name: Holidays
  - name: Integrations
  - name: Journal Entries
  - name: Overtime Rates
  - name: Partners
  - name: Pay Rates
  - name: Pay Schedules
  - name: Pay Splits
  - name: Pay Stubs
  - name: Payments
  - name: Payrolls
  - name: Reimbursements
  - name: Reimbursement Line Items
  - name: Reimbursement Types
  - name: Remittance Accounts
  - name: Remittance Account Enrollments
  - name: Reports
  - name: Statutory Withholding Line Items
  - name: Statutory Withholding Types
  - name: Tags
  - name: Tag Groups
  - name: Tax Properties
  - name: Tax Property Templates
  - name: Tokens
  - name: Usage Records
  - name: Usage Summaries
  - name: Vacation Pay
  - name: Vacation Pay Settings
  - name: Webhooks
  - name: Work Assignments
paths:
  /forms/{form}/submit:
    post:
      tags:
        - Forms
      summary: Submit a form
      description: >-
        Endpoint to submit a Form.


        The following example is for an ROE, but the same flow will work for any
        submittable form.
      operationId: forms-submit
      parameters:
        - name: form
          in: path
          schema:
            type: string
          required: true
      requestBody:
        content:
          application/json:
            schema:
              type: object
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                    description: The unique identifier of the object in Nmbr.
                    readOnly: true
                  object:
                    type: string
                    description: The type of the object in Nmbr (`"form"`).
                    readOnly: true
                  data:
                    $ref: '#/components/schemas/Form'
              example:
                id: <id>
                object: form
                data:
                  owner:
                    id: <id>
                    object: employee
                    links:
                      self: /employees/<id>
                  form_batch: null
                  stage: original
                  note: null
                  type: roe
                  effective_date: '2026-09-01'
                  version_year: '2026'
                  version_month: august
                  validation_error_count: 0
                  status: done
                  is_editable: false
                  metadata:
                    flags:
                      is_editable: false
                      is_submittable: false
                      is_amendable: false
                      is_xml_exportable: true
                      is_pdf_exportable: false
                    details:
                      submission_setting: manual
                      business_entity_name: null
                      roe_format: expanded
                  block_1_serial_number: null
                  block_2_serial_number_of_amended_or_replaced: null
                  block_3_employer_payroll_reference_number: null
                  block_5_cra_payroll_account_number: 888888880RP0001
                  block_6_pay_period_type: B
                  employer_name: Acme Widgets Ltd
                  employer_address_line_1: 200 King Street West
                  employer_address_line_2: Toronto ON
                  employer_address_line_3: null
                  employer_postal_code: M5H3T4
                  block_8_social_insurance_number: '196710156'
                  employee_first_name: Marley
                  employee_initial: B
                  employee_last_name: Prosacco
                  employee_address_line_1: 456 Oak Avenue
                  employee_address_line_2: Toronto
                  employee_address_line_3: ON CA
                  employee_postal_code: M4B1B3
                  block_13_occupation: null
                  block_10_first_day_worked: '2025-10-07'
                  block_11_last_day_for_which_paid: '2025-12-25'
                  block_12_final_pay_period_ending_date: '2025-12-29'
                  block_16_separation_code: A00
                  block_14_expected_recall_code: U
                  block_14_expected_recall_date: null
                  contact_first_name: Sam
                  contact_last_name: Smith
                  contact_area_code: 555
                  contact_phone_number: 5550199
                  contact_phone_number_extension: null
                  pp1_period_end_date: '2025-12-29'
                  pp1_insurable_earnings: 2000
                  pp1_insurable_hours: 75
                  pp2_period_end_date: '2025-12-15'
                  pp2_insurable_earnings: 2000
                  pp2_insurable_hours: 75
                  pp3_period_end_date: '2025-12-01'
                  pp3_insurable_earnings: 2000
                  pp3_insurable_hours: 75
                  pp4_period_end_date: '2025-11-17'
                  pp4_insurable_earnings: 2000
                  pp4_insurable_hours: 75
                  pp5_period_end_date: '2025-11-03'
                  pp5_insurable_earnings: 2000
                  pp5_insurable_hours: 75
                  pp6_period_end_date: '2025-10-20'
                  pp6_insurable_earnings: 2000
                  pp6_insurable_hours: 75
                  pp7_period_end_date: null
                  pp7_insurable_earnings: null
                  pp7_insurable_hours: null
                  pp8_period_end_date: null
                  pp8_insurable_earnings: null
                  pp8_insurable_hours: null
                  pp9_period_end_date: null
                  pp9_insurable_earnings: null
                  pp9_insurable_hours: null
                  pp10_period_end_date: null
                  pp10_insurable_earnings: null
                  pp10_insurable_hours: null
                  pp11_period_end_date: null
                  pp11_insurable_earnings: null
                  pp11_insurable_hours: null
                  pp12_period_end_date: null
                  pp12_insurable_earnings: null
                  pp12_insurable_hours: null
                  pp13_period_end_date: null
                  pp13_insurable_earnings: null
                  pp13_insurable_hours: null
                  pp14_period_end_date: null
                  pp14_insurable_earnings: null
                  pp14_insurable_hours: null
                  pp15_period_end_date: null
                  pp15_insurable_earnings: null
                  pp15_insurable_hours: null
                  pp16_period_end_date: null
                  pp16_insurable_earnings: null
                  pp16_insurable_hours: null
                  pp17_period_end_date: null
                  pp17_insurable_earnings: null
                  pp17_insurable_hours: null
                  pp18_period_end_date: null
                  pp18_insurable_earnings: null
                  pp18_insurable_hours: null
                  pp19_period_end_date: null
                  pp19_insurable_earnings: null
                  pp19_insurable_hours: null
                  pp20_period_end_date: null
                  pp20_insurable_earnings: null
                  pp20_insurable_hours: null
                  pp21_period_end_date: null
                  pp21_insurable_earnings: null
                  pp21_insurable_hours: null
                  pp22_period_end_date: null
                  pp22_insurable_earnings: null
                  pp22_insurable_hours: null
                  pp23_period_end_date: null
                  pp23_insurable_earnings: null
                  pp23_insurable_hours: null
                  pp24_period_end_date: null
                  pp24_insurable_earnings: null
                  pp24_insurable_hours: null
                  pp25_period_end_date: null
                  pp25_insurable_earnings: null
                  pp25_insurable_hours: null
                  pp26_period_end_date: null
                  pp26_insurable_earnings: null
                  pp26_insurable_hours: null
                  pp27_period_end_date: null
                  pp27_insurable_earnings: null
                  pp27_insurable_hours: null
                  pp28_period_end_date: null
                  pp28_insurable_earnings: null
                  pp28_insurable_hours: null
                  pp29_period_end_date: null
                  pp29_insurable_earnings: null
                  pp29_insurable_hours: null
                  pp30_period_end_date: null
                  pp30_insurable_earnings: null
                  pp30_insurable_hours: null
                  pp31_period_end_date: null
                  pp31_insurable_earnings: null
                  pp31_insurable_hours: null
                  pp32_period_end_date: null
                  pp32_insurable_earnings: null
                  pp32_insurable_hours: null
                  pp33_period_end_date: null
                  pp33_insurable_earnings: null
                  pp33_insurable_hours: null
                  pp34_period_end_date: null
                  pp34_insurable_earnings: null
                  pp34_insurable_hours: null
                  pp35_period_end_date: null
                  pp35_insurable_earnings: null
                  pp35_insurable_hours: null
                  pp36_period_end_date: null
                  pp36_insurable_earnings: null
                  pp36_insurable_hours: null
                  pp37_period_end_date: null
                  pp37_insurable_earnings: null
                  pp37_insurable_hours: null
                  pp38_period_end_date: null
                  pp38_insurable_earnings: null
                  pp38_insurable_hours: null
                  pp39_period_end_date: null
                  pp39_insurable_earnings: null
                  pp39_insurable_hours: null
                  pp40_period_end_date: null
                  pp40_insurable_earnings: null
                  pp40_insurable_hours: null
                  pp41_period_end_date: null
                  pp41_insurable_earnings: null
                  pp41_insurable_hours: null
                  pp42_period_end_date: null
                  pp42_insurable_earnings: null
                  pp42_insurable_hours: null
                  pp43_period_end_date: null
                  pp43_insurable_earnings: null
                  pp43_insurable_hours: null
                  pp44_period_end_date: null
                  pp44_insurable_earnings: null
                  pp44_insurable_hours: null
                  pp45_period_end_date: null
                  pp45_insurable_earnings: null
                  pp45_insurable_hours: null
                  pp46_period_end_date: null
                  pp46_insurable_earnings: null
                  pp46_insurable_hours: null
                  pp47_period_end_date: null
                  pp47_insurable_earnings: null
                  pp47_insurable_hours: null
                  pp48_period_end_date: null
                  pp48_insurable_earnings: null
                  pp48_insurable_hours: null
                  pp49_period_end_date: null
                  pp49_insurable_earnings: null
                  pp49_insurable_hours: null
                  pp50_period_end_date: null
                  pp50_insurable_earnings: null
                  pp50_insurable_hours: null
                  pp51_period_end_date: null
                  pp51_insurable_earnings: null
                  pp51_insurable_hours: null
                  pp52_period_end_date: null
                  pp52_insurable_earnings: null
                  pp52_insurable_hours: null
                  pp53_period_end_date: null
                  pp53_insurable_earnings: null
                  pp53_insurable_hours: null
                  vacation_pay_code: null
                  vacation_pay_start_date: null
                  vacation_pay_end_date: null
                  vacation_pay_amount: null
                  statutory_holiday_pay_for_date_1: null
                  statutory_holiday_pay_for_amount_1: null
                  statutory_holiday_pay_for_date_2: null
                  statutory_holiday_pay_for_amount_2: null
                  statutory_holiday_pay_for_date_3: null
                  statutory_holiday_pay_for_amount_3: null
                  statutory_holiday_pay_for_date_4: null
                  statutory_holiday_pay_for_amount_4: null
                  statutory_holiday_pay_for_date_5: null
                  statutory_holiday_pay_for_amount_5: null
                  statutory_holiday_pay_for_date_6: null
                  statutory_holiday_pay_for_amount_6: null
                  statutory_holiday_pay_for_date_7: null
                  statutory_holiday_pay_for_amount_7: null
                  statutory_holiday_pay_for_date_8: null
                  statutory_holiday_pay_for_amount_8: null
                  statutory_holiday_pay_for_date_9: null
                  statutory_holiday_pay_for_amount_9: null
                  statutory_holiday_pay_for_date_10: null
                  statutory_holiday_pay_for_amount_10: null
                  other_monies_code_1: null
                  other_monies_start_date_1: null
                  other_monies_end_date_1: null
                  other_monies_amount_1: null
                  other_monies_code_2: null
                  other_monies_start_date_2: null
                  other_monies_end_date_2: null
                  other_monies_amount_2: null
                  other_monies_code_3: null
                  other_monies_start_date_3: null
                  other_monies_end_date_3: null
                  other_monies_amount_3: null
                  special_payments_code_1: null
                  special_payments_start_date_1: null
                  special_payments_end_date_1: null
                  special_payments_amount_1: null
                  special_payments_period_1: null
                  special_payments_code_2: null
                  special_payments_start_date_2: null
                  special_payments_end_date_2: null
                  special_payments_amount_2: null
                  special_payments_period_2: null
                  special_payments_code_3: null
                  special_payments_start_date_3: null
                  special_payments_end_date_3: null
                  special_payments_amount_3: null
                  special_payments_period_3: null
                  special_payments_code_4: null
                  special_payments_start_date_4: null
                  special_payments_end_date_4: null
                  special_payments_amount_4: null
                  special_payments_period_4: null
                  block_18_comments: null
                  created_at: '2026-01-01T00:00:00.000000Z'
                  updated_at: '2026-01-01T00:00:00.000000Z'
                links:
                  self: /forms/<id>
components:
  schemas:
    Form:
      type: object
      title: Form
      properties:
        owner:
          type: object
          description: >-
            The owner of this form. Can be a Work Assignment, Employee, or
            Contractor.
          properties:
            id:
              type: string
              description: The unique identifier of the object in Nmbr.
              readOnly: true
            object:
              type: string
              description: The type of the object in Nmbr (`"work_assignment"`).
              readOnly: true
        form_batch:
          description: The Form Batch this form belongs to, if any.
        stage:
          type: string
          description: >-
            The lifecycle stage of this form: original, amendment, or
            cancellation.
          enum:
            - amendment
            - cancellation
            - original
        note:
          type: string
          description: An optional note for this form.
          nullable: true
        type:
          type: string
          description: The type of form (e.g. T4, ROE, RL-1).
          maxLength: 255
          enum:
            - rl1
            - roe
            - t4
            - t4a
            - td1
            - td1ab
            - td1bc
            - td1mb
            - td1nb
            - td1nl
            - td1ns
            - td1nt
            - td1nu
            - td1on
            - td1pe
            - td1sk
            - td1x
            - td1yt
            - tp_1015_3_v
            - tp_1015_r_13_v
        effective_date:
          type: string
          description: >-
            The effective date used to determine the form variant (e.g. the T4
            tax year).
          format: date
        version_year:
          type: string
          description: >-
            The form variant's version year. New versions are typically released
            in January. Note: the version year may differ from the tax year. For
            example, income earned in the 2025 tax year is typically reported on
            a 2026 version of the T4.
          nullable: true
        version_month:
          type: string
          description: >-
            The month component of the form variant, for forms with monthly
            variants. `null` for annual forms.
          nullable: true
        validation_error_count:
          type: number
          description: >-
            The number of validation errors currently present in the form's
            fields.
          nullable: true
          format: decimal
        is_editable:
          type: boolean
          description: |-
            Whether the form can be edited.

            Whether the form can currently be modified.
        line_1_basic_personal_amount: {}
        line_2_infirm_children_caregiver_amount: {}
        line_3_age_amount: {}
        line_4_pension_income_amount: {}
        line_5_tuition: {}
        line_6_disability_amount: {}
        line_7_spouse_or_common_law_partner_amount: {}
        line_8_eligible_dependent_amount: {}
        line_9_infirm_dependent_caregiver_amount: {}
        line_10_dependent_caregiver_amount: {}
        line_11_spouse_or_common_law_transfer_amount: {}
        line_12_dependent_transfer_amount: {}
        line_13_total_claim_amount: {}
        more_than_one_employer_or_payer: {}
        total_income_less_than_total_claim_amount: {}
        ninety_percent_world_income_taxable_income: {}
        prescribed_zone_deduction: {}
        additional_tax_deduction: {}
        created_at:
          type: string
          description: The date and time the object was created in Nmbr.
          readOnly: true
          format: dateTime
        updated_at:
          type: string
          description: The date and time the object was last updated in Nmbr.
          readOnly: true
          format: dateTime
  securitySchemes:
    CompanyToken:
      type: http
      scheme: bearer

````